var http = require('http'); // HTTP module
var maValeur = 42; // la valeur reçue de p5js
var serverhttp = http.createServer(handleRequest); // Create a server with the handleRequest callback
var handleRequest = function (request, response) {
response.write(maValeur+'\n');  // écrit la valeur    
};
var monUtilisateur;
serverhttp.listen(8080); // Listen on port 8080


var dgram = require("dgram");
var server = dgram.createSocket("udp4");
var fs = require('fs');

var crlf = new Buffer(2);
crlf[0] = 0xD; //CR - Carriage return character
crlf[1] = 0xA; //LF - Line feed character

server.on("message", function (msg, rinfo) { //every time new data arrives do this:
  console.log("server got: " + msg.readUInt16LE(0) + " from " + rinfo.address + ":" + rinfo.port); // you can comment this line out
///////  fs.appendFile('mydata.txt', msg.readUInt16LE(0) + crlf, encoding='utf8');//write the value to file and add CRLF for line break
    maValeur = msg.readUInt16LE(0);
    // io.sockets.emit('test', "this goes to everyone");
         io.to(monUtilisateur).emit('test', maValeur);   
});

server.on("listening", function () {
  var address = server.address();
  console.log("server listening " + address.address + ":" + address.port);
});

server.bind(6000); //listen to udp traffic on port 6000

////////////////////////////////////////////////////////////////////////
// WebSocket pour la page index.html qui envoie la valeur au serveur
// WebSockets work with the HTTP server

var io = require('socket.io').listen(serverhttp);

// Register a callback function to run when we have an individual connection
// This is run for each individual user that connects
io.sockets.on('connection',
  // We are given a websocket object in our function
  function (socket) {
  
    console.log("Nous avons un nouveau client: " + socket.id);
    monUtilisateur = socket.id;
    
    // Quand ce client émet, client side: socket.emit('otherevent',some data);
    socket.on('datos',
      function(data) {
        // Data comes in as whatever was sent, including objects
        console.log("Received: 'datos' " + data);
        
        //maValeur = data; // attribue la valeur de 'data' à MaValeur
        console.log(socket.id);
        // envoi à tous les autres clients
        io.to(monUtilisateur).emit('test', maValeur);
        //console.log('message envoyé');
        //socket.broadcast.emit('test', 666);
        
        // This is a way to send to everyone including sender
        //io.sockets.emit('message', "this goes to everyone");

      }
    );
    
    socket.on('disconnect', function() {
      console.log("Client has disconnected");
    });
  }
);